<?php
/**
 * 2021 Addify
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Academic Free License (AFL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/afl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please refer to http://www.prestashop.com for more information.
 *
 *  @author    Addify
 *  @copyright 2021 Addify
 *  @license   http://opensource.org/licenses/afl-3.0.php
 */

if (!defined('_PS_VERSION_')) {
    exit;
}
class AddifyfreegiftspredefinedModel extends ObjectModel
{
	public $id;
    public $title;
    public $rule_active;
    public $priority;
    public $buy_product;
    public $gift_type;
    public $rule_type;
    public $userbuy_type;
    public $buy_supplier;
    public $buy_category;
    public $giftbuy_type;
    public $gift_quantity;
    public $gift_product;
    public $gift_category;
    public $gift_supplier;
    public $Validity_from;
    public $Validity_to;
    public $date_add;
    public $date_update;
	public static $definition = array(
        'table'     => 'addifyfreegiftspredefined',
        'primary'   => 'id',
        'multilang' => false,
        'fields'    => array(
            'title'            => array('type' => self::TYPE_HTML),
            'date_add'         => array('type' => self::TYPE_DATE, 'validate' => 'isDate'),
            'date_update'      => array('type' => self::TYPE_DATE, 'validate' => 'isDate'),
            'rule_active'      => array('type' => self::TYPE_BOOL, 'validate' => 'isBool'),
            'priority'      => array('type' => self::TYPE_INT),
            'buy_product'          => array('type' => self::TYPE_HTML),
            'gift_type'          => array('type' => self::TYPE_HTML),
            'rule_type'          => array('type' => self::TYPE_HTML),
            'userbuy_type'          => array('type' => self::TYPE_HTML),
            'buy_supplier'          => array('type' => self::TYPE_HTML),
            'Validity_from'          => array('type' => self::TYPE_HTML),
            'Validity_to'          => array('type' => self::TYPE_HTML),
            'buy_category'          => array('type' => self::TYPE_HTML),
            'giftbuy_type'          => array('type' => self::TYPE_HTML),
            'gift_quantity'          => array('type' => self::TYPE_HTML),
            'gift_product'          => array('type' => self::TYPE_HTML),
            'gift_category'          => array('type' => self::TYPE_HTML),
            'gift_supplier'          => array('type' => self::TYPE_HTML),

    ));

	public static function getposts()
	{
		return Db::getInstance()->executeS('
			SELECT *
			FROM `'._DB_PREFIX_.'addifyfreegiftspredefined`');
	}

    public static function setStatus($status, $id)
    {
        if (!$id || empty($status)) {
            return false;
        }
        return (bool)Db::getInstance()->execute('UPDATE '._DB_PREFIX_.self::$definition['table'].'
            SET `'.pSQL($status).'` = !'.pSQL($status).'
            WHERE id = '.(int)$id);
    }

    public static function searchProduct()
    {
        $query = Tools::getValue('q', false);
        if (!$query or $query == '' or Tools::strlen($query) < 1) {
            die();
        }

        /*
         * In the SQL request the "q" param is used entirely to match result in database.
         * In this way if string:"(ref : #ref_pattern#)" is displayed on the return list,
         * they are no return values just because string:"(ref : #ref_pattern#)"
         * is not write in the name field of the product.
         * So the ref pattern will be cut for the search request.
         */
        if ($pos = strpos($query, ' (ref:')) {
            $query = Tools::substr($query, 0, $pos);
        }

        $excludeIds = Tools::getValue('excludeIds', false);
        if ($excludeIds && $excludeIds != 'NaN') {
            $excludeIds = implode(',', array_map('intval', explode(',', $excludeIds)));
        } else {
            $excludeIds = '';
            $excludePackItself= Tools::getValue('packItself', false);
        }

        // Excluding downloadable products from packs because download from pack is not supported
        $excludeVirtuals = (bool)Tools::getValue('excludeVirtuals', true);
        $exclude_packs = (bool)Tools::getValue('exclude_packs', true);

        $context = Context::getContext();

        $sql = 'SELECT p.`id_product`, pl.`link_rewrite`, p.`reference`, pl.`name`, image_shop.`id_image` id_image, il.`legend`, p.`cache_default_attribute`
                FROM `'._DB_PREFIX_.'product` p
                '.Shop::addSqlAssociation('product', 'p').'
                LEFT JOIN `'._DB_PREFIX_.'product_lang` pl ON (pl.id_product = p.id_product AND pl.id_lang = '.(int)$context->language->id.Shop::addSqlRestrictionOnLang('pl').')
                LEFT JOIN `'._DB_PREFIX_.'image_shop` image_shop
                    ON (image_shop.`id_product` = p.`id_product` AND image_shop.cover=1 AND image_shop.id_shop='.(int)$context->shop->id.')
                LEFT JOIN `'._DB_PREFIX_.'image_lang` il ON (image_shop.`id_image` = il.`id_image` AND il.`id_lang` = '.(int)$context->language->id.')
                WHERE (pl.name LIKE \'%'.pSQL($query).'%\' OR p.reference LIKE \'%'.pSQL($query).'%\')'.
            (!empty($excludeIds) ? ' AND p.id_product NOT IN ('.$excludeIds.') ' : ' ').
            (!empty($excludePackItself) ? ' AND p.id_product <> '.$excludePackItself.' ' : ' ').
            ($excludeVirtuals ? 'AND NOT EXISTS (SELECT 1 FROM `'._DB_PREFIX_.'product_download` pd WHERE (pd.id_product = p.id_product))' : '').
            ($exclude_packs ? 'AND (p.cache_is_pack IS NULL OR p.cache_is_pack = 0)' : '').
            ' GROUP BY p.id_product';

        $items = Db::getInstance()->executeS($sql);

        if ($items) {
            foreach ($items as $item) {
                $item['name'] = str_replace('|', '&#124;', $item['name']);
                echo trim($item['name']).(!empty($item['reference']) ? ' (ref: '.$item['reference'].')' : '').'|'.(int)($item['id_product'])."\n";
            }
        }
        die();
    }

    public static function getProductById($id_product)
    {
        return Db::getInstance()->getRow('SELECT `id_product`, `name`
            FROM `'._DB_PREFIX_.'product_lang` WHERE `id_product` = '.(int)$id_product);
    }

    public static function getPreDefinedRule()
    {
        return Db::getInstance()->executeS('
            SELECT *
            FROM `'._DB_PREFIX_.'addifyfreegiftspredefined`WHERE rule_active = 1');
    }

    public static function getPreDefinedRuleById($rule_id, $today)
    {
        $result = Db::getInstance()->executeS('
            SELECT *
            FROM `'._DB_PREFIX_.'addifyfreegiftspredefined`WHERE rule_active = 1 AND id = '.(int)$rule_id);

        if ($result) {

            if (($today >= $result[0]['Validity_from'] || $result[0]['Validity_from'] =='' || $result[0]['Validity_from'] == '0000-00-00') && (
            $today <= $result[0]['Validity_to'] || $result[0]['Validity_to'] =='' || $result[0]['Validity_to'] == '0000-00-00' ))
            {
                
                return $result;
            }
        }
    }

    public static function specific_price_rule_exists($id_product, $id_product_attribute, $id_shop, $id_group, $id_country, $id_currency, $id_customer, $from_quantity, $from, $to, $id_cart)
    {
        return (int) Db::getInstance()->getValue('SELECT `id_specific_price`
            FROM ' . _DB_PREFIX_ . 'specific_price
            WHERE `id_product`=' . (int) $id_product . ' AND
                `id_product_attribute`=' . (int) $id_product_attribute . ' AND
                `id_shop`=' . (int) $id_shop . ' AND
                `id_group`=' . (int) $id_group . ' AND
                `id_country`=' . (int) $id_country . ' AND
                `id_currency`=' . (int) $id_currency . ' AND
                `id_customer`=' . (int) $id_customer . ' AND
                `from_quantity`=' . (int) $from_quantity . ' AND
                `from` >= \'' . pSQL($from) . '\' AND
                `to` <= \'' . pSQL($to) . '\' AND
                `id_cart`=' . (int) $id_cart);
    }

    public static function getPreDefinedRuleDelete($cart_pro_ids, $cart_categ_ids, $cart_supp_ids, $id_lang)
    {
        $results = Db::getInstance()->executeS('
            SELECT *
            FROM `'._DB_PREFIX_.'addifyfreegiftspredefined` WHERE rule_active = 1 ORDER BY priority ASC');

        if ($results) {
            foreach ($results as $result) {

                if ($result['rule_type'] == 0) {
                    
                    if ($result['userbuy_type'] == 0) {
                        $i=0;
                        $products = Product::getProducts($id_lang, 0, 0, 'id_product', 'ASC');

                        foreach ($products as $product) {
                            $id_product = $product['id_product'];
                            if (Context::getContext()->cookie->Add_gift_ids) {
                                $explode_gift_ids = explode(',', Context::getContext()->cookie->Add_gift_ids);
                                if (!in_array($id_product, $explode_gift_ids)) {
                                    if (in_array($id_product, $cart_pro_ids)) {
                                        $i++;
                                    }
                                }
                            }
                            else{
                                if (in_array($id_product, $cart_pro_ids)) {
                                    $i++;
                                }
                            }
                        }

                        if ($i < 1) {
                            return $result;
                        }
                    }
                    elseif ($result['userbuy_type'] == 1) {
                        $i=0;
                        if (!empty($result['buy_product'])) {
                            $products_ids = explode(",",$result['buy_product']);
                            foreach ($products_ids as $value) {
                                if (Context::getContext()->cookie->Add_gift_ids) {
                                    $explode_gift_ids = explode(',', Context::getContext()->cookie->Add_gift_ids);
                                    if (!in_array($value, $explode_gift_ids)) {
                                        if (in_array($value, $cart_pro_ids)) {
                                            $i++;
                                        }
                                    }
                                }
                                else{
                                    if (in_array($value, $cart_pro_ids)) {
                                        $i++;
                                    }
                                }
                            }
                            
                            if ($i < 1) {
                                return $result;
                            }
                        
                        }
                    }
                    elseif ($result['userbuy_type'] == 2) {
                        $i=0;
                        if (!empty($result['buy_category'])) {
                            $category_ids = explode(",",$result['buy_category']);
                            $rule_pro_ids = [];
                            foreach ($category_ids as $key => $category_id) {

                                $products = Product::getProducts(Context::getContext()->language->id, 0, 0, 'id_product', 'ASC', $category_id);
                                $ids_products = [];
                                foreach ($products as $product) {
                                    $ids_products[] = $product['id_product'];
                                }
                                $arraymerge = array_merge($rule_pro_ids,$ids_products);
                                $rule_pro_ids = array_unique($arraymerge);
                            }

                           foreach ($rule_pro_ids as $value) {
                                if (Context::getContext()->cookie->Add_gift_ids) {
                                    $explode_gift_ids = explode(',', Context::getContext()->cookie->Add_gift_ids);
                                    if (!in_array($value, $explode_gift_ids)) {
                                        if (in_array($value, $cart_pro_ids)) {
                                            $i++;
                                        }
                                    }
                                }
                                else{
                                    if (in_array($value, $cart_pro_ids)) {
                                        $i++;
                                    }
                                }
                            }
                            
                            if ($i < 1) {
                                return $result;
                            }
                            
                        }
                    }
                    elseif ($result['userbuy_type'] == 3) {
                       $i=0;
                        if (!empty($result['buy_supplier'])) {
                            $supplier_ids = explode(",",$result['buy_supplier']);
                            $rule_pro_ids = [];
                            foreach ($supplier_ids as $key => $supplier_id) {

                                $sql = 'SELECT DISTINCT p.`id_product`
                                    FROM `'._DB_PREFIX_.'product_supplier` ps
                                    LEFT JOIN `'._DB_PREFIX_.'product` p ON (ps.`id_product` = p.`id_product`)
                                    LEFT JOIN `'._DB_PREFIX_.'product_lang` pl ON (p.`id_product` = pl.`id_product`)
                                    WHERE ps.`id_supplier` = '.(int)$supplier_id.' AND pl.`id_lang` = '.(int)Context::getContext()->language->id;
                                $products = Db::getInstance()->executeS($sql);
                                $ids_products = [];
                                foreach ($products as $product) {
                                    $ids_products[] = $product['id_product'];
                                }
                                $arraymerge = array_merge($rule_pro_ids,$ids_products);
                                $rule_pro_ids = array_unique($arraymerge);
                            }

                            foreach ($rule_pro_ids as $value) {
                                if (Context::getContext()->cookie->Add_gift_ids) {
                                    $explode_gift_ids = explode(',', Context::getContext()->cookie->Add_gift_ids);
                                    if (!in_array($value, $explode_gift_ids)) {
                                        if (in_array($value, $cart_pro_ids)) {
                                            $i++;
                                        }
                                    }
                                }
                                else{
                                    if (in_array($value, $cart_pro_ids)) {
                                        $i++;
                                    }
                                }
                            }
                            
                            if ($i < 1) {
                                return $result;
                            }
                            
                        }
                    }
                }
                elseif ($result['rule_type'] == 1) {

                    
                    if ($result['userbuy_type'] == 0) {
                        $i=0;
                        $products = Product::getProducts($id_lang, 0, 0, 'id_product', 'ASC');
                        foreach ($products as $product) {
                            $id_product = $product['id_product'];
                            if (Context::getContext()->cookie->Add_gift_ids) {
                                $explode_gift_ids = explode(',', Context::getContext()->cookie->Add_gift_ids);
                                if (!in_array($id_product, $explode_gift_ids)) {
                                    if (in_array($id_product, $cart_pro_ids)) {
                                        $i++;
                                    }
                                }
                            }
                            else{
                                if (in_array($id_product, $cart_pro_ids)) {
                                    $i++;
                                }
                            }
                        }

                        if ($i < 2) {
                            return $result;
                        }
                    }
                    elseif ($result['userbuy_type'] == 1) {
                        $i=0;
                        if (!empty($result['buy_product'])) {
                            $products_ids = explode(",",$result['buy_product']);
                            foreach ($products_ids as $value) {
                                if (Context::getContext()->cookie->Add_gift_ids) {
                                    $explode_gift_ids = explode(',', Context::getContext()->cookie->Add_gift_ids);
                                    if (!in_array($value, $explode_gift_ids)) {
                                        if (in_array($value, $cart_pro_ids)) {
                                            $i++;
                                        }
                                    }
                                }
                                else{
                                    if (in_array($value, $cart_pro_ids)) {
                                        $i++;
                                    }
                                }
                            }
                            
                            if ($i < 2) {
                                return $result;
                            }
                        
                        }
                    }
                    elseif ($result['userbuy_type'] == 2) {
                        $i=0;
                        if (!empty($result['buy_category'])) {
                            $category_ids = explode(",",$result['buy_category']);
                            $rule_pro_ids = [];
                            foreach ($category_ids as $key => $category_id) {

                                $products = Product::getProducts(Context::getContext()->language->id, 0, 0, 'id_product', 'ASC', $category_id);
                                $ids_products = [];
                                foreach ($products as $product) {
                                    $ids_products[] = $product['id_product'];
                                }
                                $arraymerge = array_merge($rule_pro_ids,$ids_products);
                                $rule_pro_ids = array_unique($arraymerge);
                            }

                           foreach ($rule_pro_ids as $value) {
                                if (Context::getContext()->cookie->Add_gift_ids) {
                                    $explode_gift_ids = explode(',', Context::getContext()->cookie->Add_gift_ids);
                                    if (!in_array($value, $explode_gift_ids)) {
                                        if (in_array($value, $cart_pro_ids)) {
                                            $i++;
                                        }
                                    }
                                }
                                else{
                                    if (in_array($value, $cart_pro_ids)) {
                                        $i++;
                                    }
                                }
                            }
                            
                            if ($i < 2) {
                                return $result;
                            }
                            
                        }
                    }
                    elseif ($result['userbuy_type'] == 3) {
                       $i=0;
                        if (!empty($result['buy_supplier'])) {
                            $supplier_ids = explode(",",$result['buy_supplier']);
                            $rule_pro_ids = [];
                            foreach ($supplier_ids as $key => $supplier_id) {

                                $sql = 'SELECT DISTINCT p.`id_product`
                                    FROM `'._DB_PREFIX_.'product_supplier` ps
                                    LEFT JOIN `'._DB_PREFIX_.'product` p ON (ps.`id_product` = p.`id_product`)
                                    LEFT JOIN `'._DB_PREFIX_.'product_lang` pl ON (p.`id_product` = pl.`id_product`)
                                    WHERE ps.`id_supplier` = '.(int)$supplier_id.' AND pl.`id_lang` = '.(int)Context::getContext()->language->id;
                                $products = Db::getInstance()->executeS($sql);
                                $ids_products = [];
                                foreach ($products as $product) {
                                    $ids_products[] = $product['id_product'];
                                }
                                $arraymerge = array_merge($rule_pro_ids,$ids_products);
                                $rule_pro_ids = array_unique($arraymerge);
                            }

                            foreach ($rule_pro_ids as $value) {
                                if (Context::getContext()->cookie->Add_gift_ids) {
                                    $explode_gift_ids = explode(',', Context::getContext()->cookie->Add_gift_ids);
                                    if (!in_array($value, $explode_gift_ids)) {
                                        if (in_array($value, $cart_pro_ids)) {
                                            $i++;
                                        }
                                    }
                                }
                                else{
                                    if (in_array($value, $cart_pro_ids)) {
                                        $i++;
                                    }
                                }
                            }
                            
                            if ($i < 2) {
                                return $result;
                            }
                            
                        }
                    }
                   
                }
                elseif ($result['rule_type'] == 2) {

                    if ($result['userbuy_type'] == 0) {
                        $i=0;
                        $products = Product::getProducts($id_lang, 0, 0, 'id_product', 'ASC');
                        foreach ($products as $product) {
                            $id_product = $product['id_product'];
                            if (Context::getContext()->cookie->Add_gift_ids) {
                                $explode_gift_ids = explode(',', Context::getContext()->cookie->Add_gift_ids);
                                if (!in_array($id_product, $explode_gift_ids)) {
                                    if (in_array($id_product, $cart_pro_ids)) {
                                        $i++;
                                    }
                                }
                            }
                            else{
                                if (in_array($id_product, $cart_pro_ids)) {
                                    $i++;
                                }
                            }
                        }

                        if ($i < 3) {
                            return $result;
                        }
                    }
                    elseif ($result['userbuy_type'] == 1) {
                        $i=0;
                        if (!empty($result['buy_product'])) {
                            $products_ids = explode(",",$result['buy_product']);
                            foreach ($products_ids as $value) {
                                if (Context::getContext()->cookie->Add_gift_ids) {
                                    $explode_gift_ids = explode(',', Context::getContext()->cookie->Add_gift_ids);
                                    if (!in_array($value, $explode_gift_ids)) {
                                        if (in_array($value, $cart_pro_ids)) {
                                            $i++;
                                        }
                                    }
                                }
                                else{
                                    if (in_array($value, $cart_pro_ids)) {
                                        $i++;
                                    }
                                }
                            }
                            
                            if ($i < 3) {
                                return $result;
                            }
                        
                        }
                    }
                    elseif ($result['userbuy_type'] == 2) {
                        $i=0;
                        if (!empty($result['buy_category'])) {
                            $category_ids = explode(",",$result['buy_category']);
                            $rule_pro_ids = [];
                            foreach ($category_ids as $key => $category_id) {

                                $products = Product::getProducts(Context::getContext()->language->id, 0, 0, 'id_product', 'ASC', $category_id);
                                $ids_products = [];
                                foreach ($products as $product) {
                                    $ids_products[] = $product['id_product'];
                                }
                                $arraymerge = array_merge($rule_pro_ids,$ids_products);
                                $rule_pro_ids = array_unique($arraymerge);
                            }

                           foreach ($rule_pro_ids as $value) {
                                if (Context::getContext()->cookie->Add_gift_ids) {
                                    $explode_gift_ids = explode(',', Context::getContext()->cookie->Add_gift_ids);
                                    if (!in_array($value, $explode_gift_ids)) {
                                        if (in_array($value, $cart_pro_ids)) {
                                            $i++;
                                        }
                                    }
                                }
                                else{
                                    if (in_array($value, $cart_pro_ids)) {
                                        $i++;
                                    }
                                }
                            }
                            
                            if ($i < 3) {
                                return $result;
                            }
                            
                        }
                    }
                    elseif ($result['userbuy_type'] == 3) {
                       $i=0;
                        if (!empty($result['buy_supplier'])) {
                            $supplier_ids = explode(",",$result['buy_supplier']);
                            $rule_pro_ids = [];
                            foreach ($supplier_ids as $key => $supplier_id) {

                                $sql = 'SELECT DISTINCT p.`id_product`
                                    FROM `'._DB_PREFIX_.'product_supplier` ps
                                    LEFT JOIN `'._DB_PREFIX_.'product` p ON (ps.`id_product` = p.`id_product`)
                                    LEFT JOIN `'._DB_PREFIX_.'product_lang` pl ON (p.`id_product` = pl.`id_product`)
                                    WHERE ps.`id_supplier` = '.(int)$supplier_id.' AND pl.`id_lang` = '.(int)Context::getContext()->language->id;
                                $products = Db::getInstance()->executeS($sql);
                                $ids_products = [];
                                foreach ($products as $product) {
                                    $ids_products[] = $product['id_product'];
                                }
                                $arraymerge = array_merge($rule_pro_ids,$ids_products);
                                $rule_pro_ids = array_unique($arraymerge);
                            }

                            foreach ($rule_pro_ids as $value) {
                                if (Context::getContext()->cookie->Add_gift_ids) {
                                    $explode_gift_ids = explode(',', Context::getContext()->cookie->Add_gift_ids);
                                    if (!in_array($value, $explode_gift_ids)) {
                                        if (in_array($value, $cart_pro_ids)) {
                                            $i++;
                                        }
                                    }
                                }
                                else{
                                    if (in_array($value, $cart_pro_ids)) {
                                        $i++;
                                    }
                                }
                            }
                            
                            if ($i < 3) {
                                return $result;
                            }
                            
                        }
                    }
                }
            }
        }
    }

    public static function getProductBySupplierId($supplier_id)
    {
        $sql = 'SELECT DISTINCT p.`id_product`
            FROM `'._DB_PREFIX_.'product_supplier` ps
            LEFT JOIN `'._DB_PREFIX_.'product` p ON (ps.`id_product` = p.`id_product`)
            LEFT JOIN `'._DB_PREFIX_.'product_lang` pl ON (p.`id_product` = pl.`id_product`)
            WHERE ps.`id_supplier` = '.(int)$supplier_id.' AND pl.`id_lang` = '.(int)Context::getContext()->language->id;
        $products = Db::getInstance()->executeS($sql);
        return $products;
    }

    public static function getPreDefinedRuleOne($today, $cart_pro_ids, $cart_categ_ids, $cart_supp_ids)
    {

        $id_lang = (int) Context::getContext()->language->id;

        $results = Db::getInstance()->executeS('
            SELECT *
            FROM `'._DB_PREFIX_.'addifyfreegiftspredefined` WHERE rule_active = 1 ORDER BY priority ASC');

        if ($results) {
            foreach ($results as $result) {
                if (($today >= $result['Validity_from'] || $result['Validity_from'] =='' || $result['Validity_from'] == '0000-00-00') && (
                $today <= $result['Validity_to'] || $result['Validity_to'] =='' || $result['Validity_to'] == '0000-00-00' ))
                {
                    
                    if ($result['gift_type'] == 0 || $result['gift_type'] == 1) {

                        if ($result['rule_type'] == 0) {


                            
                            if ($result['userbuy_type'] == 0) {
                                $i=0;
                                $products = Product::getProducts($id_lang, 0, 0, 'id_product', 'ASC');
                                foreach ($products as $product) {
                                    $id_product = $product['id_product'];
                                    if (Context::getContext()->cookie->Add_gift_ids) {
                                        $explode_gift_ids = explode(',', Context::getContext()->cookie->Add_gift_ids);
                                        if (!in_array($id_product, $explode_gift_ids)) {
                                            if (in_array($id_product, $cart_pro_ids)) {
                                                $i++;
                                            }
                                        }
                                    }
                                    else{
                                        if (in_array($id_product, $cart_pro_ids)) {
                                            $i++;
                                        }
                                    }
                                }

                                if ($i >= 1) {
                                    return $result;
                                }
                            }
                            elseif ($result['userbuy_type'] == 1) {
                                $i=0;
                                if (!empty($result['buy_product'])) {
                                    $products_ids = explode(",",$result['buy_product']);
                                    foreach ($products_ids as $value) {
                                        if (Context::getContext()->cookie->Add_gift_ids) {
                                            $explode_gift_ids = explode(',', Context::getContext()->cookie->Add_gift_ids);
                                            if (!in_array($value, $explode_gift_ids)) {
                                                if (in_array($value, $cart_pro_ids)) {
                                                    $i++;
                                                }
                                            }
                                        }
                                        else{
                                            if (in_array($value, $cart_pro_ids)) {
                                                $i++;
                                            }
                                        }
                                    }
                                    
                                    if ($i >= 1) {
                                        return $result;
                                    }
                                
                                }
                            }
                            elseif ($result['userbuy_type'] == 2) {
                                $i=0;
                                if (!empty($result['buy_category'])) {
                                    $category_ids = explode(",",$result['buy_category']);
                                    $rule_pro_ids = [];
                                    foreach ($category_ids as $key => $category_id) {

                                        $products = Product::getProducts(Context::getContext()->language->id, 0, 0, 'id_product', 'ASC', $category_id);
                                        $ids_products = [];
                                        foreach ($products as $product) {
                                            $ids_products[] = $product['id_product'];
                                        }
                                        $arraymerge = array_merge($rule_pro_ids,$ids_products);
                                        $rule_pro_ids = array_unique($arraymerge);
                                    }

                                   foreach ($rule_pro_ids as $value) {

                                        if (Context::getContext()->cookie->Add_gift_ids) {
                                            $explode_gift_ids = explode(',', Context::getContext()->cookie->Add_gift_ids);
                                            if (!in_array($value, $explode_gift_ids)) {
                                                if (in_array($value, $cart_pro_ids)) {
                                                    $i++;
                                                }
                                            }
                                        }
                                        else{

                                            if (in_array($value, $cart_pro_ids)) {
                                                $i++;
                                            }
                                        }
                                    }
                                    
                                    if ($i >= 1) {
                                        return $result;
                                    }
                                    
                                }
                            }
                            elseif ($result['userbuy_type'] == 3) {
                               $i=0;
                                if (!empty($result['buy_supplier'])) {
                                    $supplier_ids = explode(",",$result['buy_supplier']);
                                    $rule_pro_ids = [];
                                    foreach ($supplier_ids as $key => $supplier_id) {

                                        $sql = 'SELECT DISTINCT p.`id_product`
                                            FROM `'._DB_PREFIX_.'product_supplier` ps
                                            LEFT JOIN `'._DB_PREFIX_.'product` p ON (ps.`id_product` = p.`id_product`)
                                            LEFT JOIN `'._DB_PREFIX_.'product_lang` pl ON (p.`id_product` = pl.`id_product`)
                                            WHERE ps.`id_supplier` = '.(int)$supplier_id.' AND pl.`id_lang` = '.(int)Context::getContext()->language->id;
                                        $products = Db::getInstance()->executeS($sql);
                                        $ids_products = [];
                                        foreach ($products as $product) {
                                            $ids_products[] = $product['id_product'];
                                        }
                                        $arraymerge = array_merge($rule_pro_ids,$ids_products);
                                        $rule_pro_ids = array_unique($arraymerge);
                                    }

                                    foreach ($rule_pro_ids as $value) {
                                        if (Context::getContext()->cookie->Add_gift_ids) {
                                            $explode_gift_ids = explode(',', Context::getContext()->cookie->Add_gift_ids);
                                            if (!in_array($value, $explode_gift_ids)) {
                                                if (in_array($value, $cart_pro_ids)) {
                                                    $i++;
                                                }
                                            }
                                        }
                                        else{
                                            if (in_array($value, $cart_pro_ids)) {
                                                $i++;
                                            }
                                        }
                                    }
                                    
                                    if ($i >= 1) {
                                        return $result;
                                    }
                                    
                                }
                            }
                        }
                        elseif ($result['rule_type'] == 1) {

                            
                            if ($result['userbuy_type'] == 0) {
                                $i=0;
                                $products = Product::getProducts($id_lang, 0, 0, 'id_product', 'ASC');
                                foreach ($products as $product) {
                                    $id_product = $product['id_product'];

                                    if (Context::getContext()->cookie->Add_gift_ids) {
                                        $explode_gift_ids = explode(',', Context::getContext()->cookie->Add_gift_ids);
                                        if (!in_array($id_product, $explode_gift_ids)) {
                                            if (in_array($id_product, $cart_pro_ids)) {
                                                $i++;
                                            }
                                        }
                                    }
                                    else{
                                        if (in_array($id_product, $cart_pro_ids)) {
                                            $i++;
                                        }
                                    }
                                }

                                if ($i >= 2) {
                                    return $result;
                                }
                            }
                            elseif ($result['userbuy_type'] == 1) {
                                $i=0;
                                if (!empty($result['buy_product'])) {
                                    $products_ids = explode(",",$result['buy_product']);
                                    foreach ($products_ids as $value) {
                                        if (Context::getContext()->cookie->Add_gift_ids) {
                                            $explode_gift_ids = explode(',', Context::getContext()->cookie->Add_gift_ids);
                                            if (!in_array($value, $explode_gift_ids)) {
                                                if (in_array($value, $cart_pro_ids)) {
                                                    $i++;
                                                }
                                            }
                                        }
                                        else{
                                            if (in_array($value, $cart_pro_ids)) {
                                                $i++;
                                            }
                                        }
                                    }
                                    
                                    if ($i >= 2) {
                                        return $result;
                                    }
                                
                                }
                            }
                            elseif ($result['userbuy_type'] == 2) {
                                $i=0;
                                if (!empty($result['buy_category'])) {
                                    $category_ids = explode(",",$result['buy_category']);

                                    $rule_pro_ids = [];
                                    foreach ($category_ids as $key => $category_id) {

                                        $products = Product::getProducts(Context::getContext()->language->id, 0, 0, 'id_product', 'ASC', $category_id);
                                        $ids_products = [];
                                        foreach ($products as $product) {
                                            $ids_products[] = $product['id_product'];
                                        }
                                        $arraymerge = array_merge($rule_pro_ids,$ids_products);
                                        $rule_pro_ids = array_unique($arraymerge);
                                    }

                                   foreach ($rule_pro_ids as $value) {
                                        if (Context::getContext()->cookie->Add_gift_ids) {
                                            $explode_gift_ids = explode(',', Context::getContext()->cookie->Add_gift_ids);
                                            if (!in_array($value, $explode_gift_ids)) {
                                                if (in_array($value, $cart_pro_ids)) {
                                                    $i++;
                                                }
                                            }
                                        }
                                        else{
                                            if (in_array($value, $cart_pro_ids)) {
                                                $i++;
                                            }
                                        }
                                    }
                                    
                                    if ($i >= 2) {
                                        return $result;
                                    }
                                    
                                }
                            }
                            elseif ($result['userbuy_type'] == 3) {
                               $i=0;
                                if (!empty($result['buy_supplier'])) {
                                    $supplier_ids = explode(",",$result['buy_supplier']);

                                    $rule_pro_ids = [];
                                    foreach ($supplier_ids as $key => $supplier_id) {

                                        $sql = 'SELECT DISTINCT p.`id_product`
                                            FROM `'._DB_PREFIX_.'product_supplier` ps
                                            LEFT JOIN `'._DB_PREFIX_.'product` p ON (ps.`id_product` = p.`id_product`)
                                            LEFT JOIN `'._DB_PREFIX_.'product_lang` pl ON (p.`id_product` = pl.`id_product`)
                                            WHERE ps.`id_supplier` = '.(int)$supplier_id.' AND pl.`id_lang` = '.(int)Context::getContext()->language->id;
                                        $products = Db::getInstance()->executeS($sql);
                                        $ids_products = [];
                                        foreach ($products as $product) {
                                            $ids_products[] = $product['id_product'];
                                        }
                                        $arraymerge = array_merge($rule_pro_ids,$ids_products);
                                        $rule_pro_ids = array_unique($arraymerge);
                                    }

                                    foreach ($rule_pro_ids as $value) {
                                        if (Context::getContext()->cookie->Add_gift_ids) {
                                            $explode_gift_ids = explode(',', Context::getContext()->cookie->Add_gift_ids);
                                            if (!in_array($value, $explode_gift_ids)) {
                                                if (in_array($value, $cart_pro_ids)) {
                                                    $i++;
                                                }
                                            }
                                        }
                                        else{
                                            if (in_array($value, $cart_pro_ids)) {
                                                $i++;
                                            }
                                        }
                                    }
                                    
                                    if ($i >= 2) {
                                        return $result;
                                    }
                                    
                                }
                            }
                           
                        }
                        elseif ($result['rule_type'] == 2) {

                            if ($result['userbuy_type'] == 0) {
                                $i=0;
                                $products = Product::getProducts($id_lang, 0, 0, 'id_product', 'ASC');
                                foreach ($products as $product) {
                                    $id_product = $product['id_product'];

                                    if (Context::getContext()->cookie->Add_gift_ids) {
                                        $explode_gift_ids = explode(',', Context::getContext()->cookie->Add_gift_ids);
                                        if (!in_array($id_product, $explode_gift_ids)) {
                                            if (in_array($id_product, $cart_pro_ids)) {
                                                $i++;
                                            }
                                        }
                                    }
                                    else{
                                        if (in_array($id_product, $cart_pro_ids)) {
                                            $i++;
                                        }
                                    }
                                }

                                if ($i >= 3) {
                                    return $result;
                                }
                            }
                            elseif ($result['userbuy_type'] == 1) {
                                $i=0;
                                if (!empty($result['buy_product'])) {
                                    $products_ids = explode(",",$result['buy_product']);
                                    foreach ($products_ids as $value) {
                                        if (Context::getContext()->cookie->Add_gift_ids) {
                                            $explode_gift_ids = explode(',', Context::getContext()->cookie->Add_gift_ids);
                                            if (!in_array($value, $explode_gift_ids)) {
                                                if (in_array($value, $cart_pro_ids)) {
                                                    $i++;
                                                }
                                            }
                                        }
                                        else{
                                            if (in_array($value, $cart_pro_ids)) {
                                                $i++;
                                            }
                                        }
                                    }
                                    
                                    if ($i >= 3) {
                                        return $result;
                                    }
                                
                                }
                            }
                            elseif ($result['userbuy_type'] == 2) {
                                $i=0;
                                if (!empty($result['buy_category'])) {
                                    $category_ids = explode(",",$result['buy_category']);
                                    $rule_pro_ids = [];
                                    foreach ($category_ids as $key => $category_id) {

                                        $products = Product::getProducts(Context::getContext()->language->id, 0, 0, 'id_product', 'ASC', $category_id);
                                        $ids_products = [];
                                        foreach ($products as $product) {
                                            $ids_products[] = $product['id_product'];
                                        }
                                        $arraymerge = array_merge($rule_pro_ids,$ids_products);
                                        $rule_pro_ids = array_unique($arraymerge);
                                    }

                                   foreach ($rule_pro_ids as $value) {
                                        if (Context::getContext()->cookie->Add_gift_ids) {
                                            $explode_gift_ids = explode(',', Context::getContext()->cookie->Add_gift_ids);
                                            if (!in_array($value, $explode_gift_ids)) {
                                                if (in_array($value, $cart_pro_ids)) {
                                                    $i++;
                                                }
                                            }
                                        }
                                        else{
                                            if (in_array($value, $cart_pro_ids)) {
                                                $i++;
                                            }
                                        }
                                    }
                                    
                                    if ($i >= 3) {
                                        return $result;
                                    }
                                    
                                }
                            }
                            elseif ($result['userbuy_type'] == 3) {
                               $i=0;
                                if (!empty($result['buy_supplier'])) {
                                    $supplier_ids = explode(",",$result['buy_supplier']);
                                    $rule_pro_ids = [];
                                    foreach ($supplier_ids as $key => $supplier_id) {

                                        $sql = 'SELECT DISTINCT p.`id_product`
                                            FROM `'._DB_PREFIX_.'product_supplier` ps
                                            LEFT JOIN `'._DB_PREFIX_.'product` p ON (ps.`id_product` = p.`id_product`)
                                            LEFT JOIN `'._DB_PREFIX_.'product_lang` pl ON (p.`id_product` = pl.`id_product`)
                                            WHERE ps.`id_supplier` = '.(int)$supplier_id.' AND pl.`id_lang` = '.(int)Context::getContext()->language->id;
                                        $products = Db::getInstance()->executeS($sql);
                                        $ids_products = [];
                                        foreach ($products as $product) {
                                            $ids_products[] = $product['id_product'];
                                        }
                                        $arraymerge = array_merge($rule_pro_ids,$ids_products);
                                        $rule_pro_ids = array_unique($arraymerge);
                                    }

                                    foreach ($rule_pro_ids as $value) {
                                        if (Context::getContext()->cookie->Add_gift_ids) {
                                            $explode_gift_ids = explode(',', Context::getContext()->cookie->Add_gift_ids);
                                            if (!in_array($value, $explode_gift_ids)) {
                                                if (in_array($value, $cart_pro_ids)) {
                                                    $i++;
                                                }
                                            }
                                        }
                                        else{
                                            if (in_array($value, $cart_pro_ids)) {
                                                $i++;
                                            }
                                        }
                                    }
                                    
                                    if ($i >= 3) {
                                        return $result;
                                    }
                                    
                                }
                            }
                           
                        }
                    }
                }
            }
        }
    }
}