<?php
/**
 * 2024 Addify
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Academic Free License (AFL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/afl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please refer to http://www.prestashop.com for more information.
 *
 *  @author    Addify
 *  @copyright 2024 Addify
 *  @license   http://opensource.org/licenses/afl-3.0.php
 */

if (!defined('_PS_VERSION_')) {
    exit;
}

/**
 * This function updates your module from previous versions to the version 1.1,
 * usefull when you modify your database, or register a new hook ...
 * Don't forget to create one file per version.
 */
function upgrade_module_1_3_0($module)
{
    /*
     * Do everything you want right there,
     * You could add a column in one of your module's tables
     */

    $sql = array();

    $sql[] = 'CREATE TABLE IF NOT EXISTS `' ._DB_PREFIX_.'addifyfreegiftspredefined` (
        `id`             INT(11) NOT NULL AUTO_INCREMENT,
        `rule_active`                 TINYINT(2),
        `title`                       TEXT,
        `priority`                    int,
        `gift_type`                    TEXT,
        `buy_product`                     TEXT,
        `date_add`                    DATE,
        `date_update`                 DATE,
        `rule_type`                   TEXT,
        `userbuy_type`                TEXT,
        `buy_supplier`                TEXT,
        `buy_category`                 TEXT,
        `Validity_from`               TEXT,
        `Validity_to`                 TEXT,
        `giftbuy_type`              TEXT,
        `gift_quantity`            TEXT,
        `gift_product`            TEXT,
        `gift_category`            TEXT,
        `gift_supplier`            TEXT,
        PRIMARY KEY                     (`id`)
    ) ENGINE='._MYSQL_ENGINE_.' DEFAULT CHARSET=utf8;';

    $sql[] = 'CREATE TABLE IF NOT EXISTS `' ._DB_PREFIX_.'addifyfreegiftspromotion` (
        `id`             INT(11) NOT NULL AUTO_INCREMENT,
        `rule_active`                 TINYINT(2),
        `title`                       TEXT,
        `condition_type`              TEXT,
        `supplier`                    TEXT,
        `product`                     TEXT,
        `date_add`                    DATE,
        `date_update`                 DATE,
        `category`                   TEXT,
        PRIMARY KEY                     (`id`)
    ) ENGINE='._MYSQL_ENGINE_.' DEFAULT CHARSET=utf8;';


    foreach ($sql as $query) {

        if (Db::getInstance()->execute($query) == false) {

            return false;

        }

    }

 
    $addifyfreegifts = "addifyfreegifts";


    $userbuy_type = Db::getInstance()->executeS("SHOW COLUMNS FROM `"._DB_PREFIX_.$addifyfreegifts."` LIKE 'userbuy_type'");
    if (!$userbuy_type) {
        Db::getInstance()->execute('ALTER TABLE `'._DB_PREFIX_.$addifyfreegifts.'` ADD COLUMN userbuy_type INT NOT NULL');
    }

    $buy_category = Db::getInstance()->executeS("SHOW COLUMNS FROM `"._DB_PREFIX_.$addifyfreegifts."` LIKE 'buy_category'");
    if (!$buy_category) {
        Db::getInstance()->execute('ALTER TABLE `'._DB_PREFIX_.$addifyfreegifts.'` ADD COLUMN buy_category TEXT');
    }

    $buy_supplier = Db::getInstance()->executeS("SHOW COLUMNS FROM `"._DB_PREFIX_.$addifyfreegifts."` LIKE 'buy_supplier'");
    if (!$buy_supplier) {
        Db::getInstance()->execute('ALTER TABLE `'._DB_PREFIX_.$addifyfreegifts.'` ADD COLUMN buy_supplier TEXT');
    }

    $giftbuy_type = Db::getInstance()->executeS("SHOW COLUMNS FROM `"._DB_PREFIX_.$addifyfreegifts."` LIKE 'giftbuy_type'");
    if (!$giftbuy_type) {
        Db::getInstance()->execute('ALTER TABLE `'._DB_PREFIX_.$addifyfreegifts.'` ADD COLUMN giftbuy_type INT NOT NULL');
    }

    $gift_category = Db::getInstance()->executeS("SHOW COLUMNS FROM `"._DB_PREFIX_.$addifyfreegifts."` LIKE 'gift_category'");
    if (!$gift_category) {
        Db::getInstance()->execute('ALTER TABLE `'._DB_PREFIX_.$addifyfreegifts.'` ADD COLUMN gift_category TEXT');
    }

    $gift_supplier = Db::getInstance()->executeS("SHOW COLUMNS FROM `"._DB_PREFIX_.$addifyfreegifts."` LIKE 'gift_supplier'");
    if (!$gift_supplier) {
        Db::getInstance()->execute('ALTER TABLE `'._DB_PREFIX_.$addifyfreegifts.'` ADD COLUMN gift_supplier TEXT');
    }

    $buy_x = Db::getInstance()->executeS("SHOW COLUMNS FROM `"._DB_PREFIX_.$addifyfreegifts."` LIKE 'buy_x'");
    if (!$buy_x) {
        Db::getInstance()->execute('ALTER TABLE `'._DB_PREFIX_.$addifyfreegifts.'` ADD COLUMN buy_x TEXT');
    }

    $get_Y = Db::getInstance()->executeS("SHOW COLUMNS FROM `"._DB_PREFIX_.$addifyfreegifts."` LIKE 'get_Y'");
    if (!$get_Y) {
        Db::getInstance()->execute('ALTER TABLE `'._DB_PREFIX_.$addifyfreegifts.'` ADD COLUMN get_Y TEXT');
    }

    $module->registerHook('displayWrapperTop');
    $module->registerHook('displayWrapperBottom');

    return true;
}
