{*
* 2024 Addify
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author    Addify
*  @copyright 2024 Addify
*  @license   http://opensource.org/licenses/afl-3.0.php
*}

{extends file="helpers/form/form.tpl"}

{block name="input"}
    {if $input.type == "products"}
      <div id="type_product" class="col-lg-9">
        <input type="hidden" name="inputRestrictedProducts" id="inputRestrictedProducts" value="{if isset($products) AND $products}{foreach from=$products item=product}{$product.id_product|escape:'htmlall':'UTF-8'}-{/foreach}{/if}" />
        <input type="hidden" name="nameRestrictedProducts" id="nameRestrictedProducts" value="{if isset($products) AND $products}{foreach from=$products item=product}{$product.name|escape:'html':'UTF-8'}¤{/foreach}{/if}" />
        <div id="ajax_choose_product">
          <div class="input-group">
            <input type="text" id="restricted_product_input" name="restricted_product_input" />
            <span class="input-group-addon"><i class="icon-search"></i></span>
          </div>
        </div>
        <p class="help-block">{l s='Search and add product(s) which you want, User will get a gift when buys any X of these products' mod='addifyfreegifts'}</p>
        <br>

        <div id="divRestrictedProducts">
          {if isset($products) AND $products}
            {foreach from=$products item=product}
              <div class="form-control-static panel">
                <button type="button" class="btn btn-danger delRestrictedProducts" name="{$product.id_product|escape:'htmlall':'UTF-8'}">
                  <i class="icon-trash text-danger"></i>
                </button>
                <input type="hidden" name="product[]" value="{$product.id_product|escape:'htmlall':'UTF-8'}">
                {$product.name|escape:'html':'UTF-8'}{if !empty($product.reference)}&nbsp;{l s='(ref: %s)' sprintf=$product.reference mod='addifyfreegifts'}{/if}
              </div>
            {/foreach}
          {/if}
        </div>
      </div>
      <div class="clearfix"></div>
    {elseif $input.type == "config_product"}
      <div id="type_product_1" class="col-lg-9">
        <input type="hidden" name="inputRestrictedProducts_1" id="inputRestrictedProducts_1" value="{if isset($config_product) AND $config_product}{foreach from=$config_product item=select_product}{$select_product.id_product|escape:'htmlall':'UTF-8'}-{/foreach}{/if}" />
        <input type="hidden" name="nameRestrictedProducts_1" id="nameRestrictedProducts_1" value="{if isset($config_product) AND $config_product}{foreach from=$config_product item=select_product}{$select_product.name|escape:'html':'UTF-8'}¤{/foreach}{/if}" />
        <div id="ajax_choose_product">
          <div class="input-group">
            <input type="text" id="restricted_product_input_1" name="restricted_product_input_1 "/>
            <span class="input-group-addon"><i class="icon-search"></i></span>
          </div>
        </div>
        <p class="help-block">{l s='Search and add product(s) which you want (Not add same product as buy product).' mod='addifyfreegifts'}</p>
        <br>

        <div id="divRestrictedProducts_1">
          {if isset($config_product) AND $config_product}
            {foreach from=$config_product item=select_product}
              <div class="form-control-static panel">
                <button type="button" class="btn btn-danger delRestrictedProducts_1" name="{$select_product.id_product|escape:'htmlall':'UTF-8'}">
                  <i class="icon-trash text-danger"></i>
                </button>
                <input type="hidden" name="select_product[]" value="{$select_product.id_product|escape:'htmlall':'UTF-8'}">
                {$select_product.name|escape:'html':'UTF-8'}{if !empty($select_product.reference)}&nbsp;{l s='(ref: %s)' sprintf=$select_product.reference mod='addifyfreegifts'}{/if}
              </div>
            {/foreach}
          {/if}
        </div>
      </div>
      <div class="clearfix"></div>
    {elseif $input.type == "gift_products"}
      <div id="type_product_2" class="col-lg-9">
        <input type="hidden" name="inputRestrictedProducts_2" id="inputRestrictedProducts_2" value="{if isset($gift_products) AND $gift_products}{foreach from=$gift_products item=gift_product}{$gift_product.id_product|escape:'htmlall':'UTF-8'}-{/foreach}{/if}" />
        <input type="hidden" name="nameRestrictedProducts_2" id="nameRestrictedProducts_2" value="{if isset($gift_products) AND $gift_products}{foreach from=$gift_products item=gift_product}{$gift_product.name|escape:'html':'UTF-8'}¤{/foreach}{/if}" />
        <div id="ajax_choose_product">
          <div class="input-group">
            <input type="text" id="restricted_product_input_2" name="restricted_product_input_2 "/>
            <span class="input-group-addon"><i class="icon-search"></i></span>
          </div>
        </div>
        <p class="help-block">{l s='Search and add product(s) which you want, Selected Products will be gifted. (Not add same product as buy product)' mod='addifyfreegifts'}</p>
        <br>

        <div id="divRestrictedProducts_2">
          {if isset($gift_products) AND $gift_products}
            {foreach from=$gift_products item=gift_product}
              <div class="form-control-static panel">
                <button type="button" class="btn btn-danger delRestrictedProducts_2" name="{$gift_product.id_product|escape:'htmlall':'UTF-8'}">
                  <i class="icon-trash text-danger"></i>
                </button>
                <input type="hidden" name="gift_product[]" value="{$gift_product.id_product|escape:'htmlall':'UTF-8'}">
                {$gift_product.name|escape:'html':'UTF-8'}{if !empty($gift_product.reference)}&nbsp;{l s='(ref: %s)' sprintf=$gift_product.reference mod='addifyfreegifts'}{/if}
              </div>
            {/foreach}
          {/if}
        </div>
      </div>
      <div class="clearfix"></div>
    {elseif $input.type == "buy_products"}
      <div id="type_product_3" class="col-lg-9">
        <input type="hidden" name="inputRestrictedProducts_3" id="inputRestrictedProducts_3" value="{if isset($buy_products) AND $buy_products}{foreach from=$buy_products item=buy_product}{$buy_product.id_product|escape:'htmlall':'UTF-8'}-{/foreach}{/if}" />
        <input type="hidden" name="nameRestrictedProducts_3" id="nameRestrictedProducts_3" value="{if isset($buy_products) AND $buy_products}{foreach from=$buy_products item=buy_product}{$buy_product.name|escape:'html':'UTF-8'}¤{/foreach}{/if}" />
        <div id="ajax_choose_product">
          <div class="input-group">
            <input type="text" id="restricted_product_input_3" name="restricted_product_input_3 "/>
            <span class="input-group-addon"><i class="icon-search"></i></span>
          </div>
        </div>
        <p class="help-block">{l s='Search and add product(s) which you want, Users will get a gift when they buy these selected products.' mod='addifyfreegifts'}</p>
        <br>

        <div id="divRestrictedProducts_3">
          {if isset($buy_products) AND $buy_products}
            {foreach from=$buy_products item=buy_product}
              <div class="form-control-static panel">
                <button type="button" class="btn btn-danger delRestrictedProducts_3" name="{$buy_product.id_product|escape:'htmlall':'UTF-8'}">
                  <i class="icon-trash text-danger"></i>
                </button>
                <input type="hidden" name="buy_product[]" value="{$buy_product.id_product|escape:'htmlall':'UTF-8'}">
                {$buy_product.name|escape:'html':'UTF-8'}{if !empty($buy_product.reference)}&nbsp;{l s='(ref: %s)' sprintf=$buy_product.reference mod='addifyfreegifts'}{/if}
              </div>
            {/foreach}
          {/if}
        </div>
      </div>
      <div class="clearfix"></div>
    {elseif $input.type == "promotionproducts"}
      <div id="type_product_4" class="col-lg-9">
        <input type="hidden" name="inputRestrictedProducts_4" id="inputRestrictedProducts_4" value="{if isset($promotionproducts) AND $promotionproducts}{foreach from=$promotionproducts item=promotion_product}{$promotion_product.id_product|escape:'htmlall':'UTF-8'}-{/foreach}{/if}" />
        <input type="hidden" name="nameRestrictedProducts_4" id="nameRestrictedProducts_4" value="{if isset($promotionproducts) AND $promotionproducts}{foreach from=$promotionproducts item=promotion_product}{$promotion_product.name|escape:'html':'UTF-8'}¤{/foreach}{/if}" />
        <div id="ajax_choose_product">
          <div class="input-group">
            <input type="text" id="restricted_product_input_4" name="restricted_product_input_4 "/>
            <span class="input-group-addon"><i class="icon-search"></i></span>
          </div>
        </div>
        <p class="help-block">{l s='Please select same products that you have selected while creating gifting rules.' mod='addifyfreegifts'}</p>
        <br>

        <div id="divRestrictedProducts_4">
          {if isset($promotionproducts) AND $promotionproducts}
            {foreach from=$promotionproducts item=promotion_product}
              <div class="form-control-static panel">
                <button type="button" class="btn btn-danger delRestrictedProducts_4" name="{$promotion_product.id_product|escape:'htmlall':'UTF-8'}">
                  <i class="icon-trash text-danger"></i>
                </button>
                <input type="hidden" name="promotion_product[]" value="{$promotion_product.id_product|escape:'htmlall':'UTF-8'}">
                {$promotion_product.name|escape:'html':'UTF-8'}{if !empty($promotion_product.reference)}&nbsp;{l s='(ref: %s)' sprintf=$promotion_product.reference mod='addifyfreegifts'}{/if}
              </div>
            {/foreach}
          {/if}
        </div>
      </div>
      <div class="clearfix"></div>
    {else}
      {$smarty.block.parent}
    {/if}

{/block}

{block name="script"}

  $('#divRestrictedProducts').delegate('.delRestrictedProducts', 'click', function(){
    self.delRestrictedProducts($(this).attr('name'));
  });
  
  $('#divRestrictedProducts_1').delegate('.delRestrictedProducts_1', 'click', function f(){
    self.delRestrictedProducts_1($(this).attr('name'));
  });

  var options = {
    minChars: 1,
    autoFill: true,
    max:20,
    matchContains: true,
    mustMatch:false,
    scroll:false,
    cacheLength:0,
    formatItem: function(item) {
      var itemStringToReturn = item[item.length - 1];
      for(var istr = 0; istr < item.length - 1;istr++) {
        itemStringToReturn += " " + item[istr];
      }
      return itemStringToReturn;
    },
    
  };

  var options_1 = {
    minChars: 1,
    autoFill: true,
    max:20,
    matchContains: true,
    mustMatch:false,
    scroll:false,
    cacheLength:0,
    formatItem: function f(item) {
      var itemStringToReturn_1 = item[item.length - 1];
      for(var istr = 0; istr < item.length - 1;istr++) {
        itemStringToReturn_1 += " " + item[istr];
      }
      return itemStringToReturn_1;
    },
    
  };

  $('#restricted_product_input')
  .autocomplete("{$context_link->getAdminLink('Adminaddifyfreegifts') nofilter}&exclude_packs=0&excludeVirtuals=0",options)
  .result(addProduct);
  $('#restricted_product_input').setOptions({
    extraParams: {
      ajax: true,
      action: 'getProducts',
      excludeIds: getRestrictedProduct()
    }
  });

   $('#restricted_product_input_1')
  .autocomplete("{$context_link->getAdminLink('Adminaddifyfreegifts') nofilter}&exclude_packs=0&excludeVirtuals=0",options_1)
  .result(addProduct_1);
  $('#restricted_product_input_1').setOptions({
    extraParams: {
      ajax: true,
      action: 'getProducts',
      excludeIds: getRestrictedProduct_1()
    }
  });

  function addProduct(event, data, formatted)
  {
    if (data !== null) {
      var productId = data[1];
      var productName = data[0];

      var $divRestrictedProducts = $('#divRestrictedProducts');
      var $inputRestrictedProducts = $('#inputRestrictedProducts');
      var $nameRestrictedProducts = $('#nameRestrictedProducts');

      /* delete product from select + add product line to the div, input_name, input_ids elements */
      $divRestrictedProducts.html($divRestrictedProducts.html() + '<div class="form-control-static panel"><button type="button" class="delRestrictedProducts btn btn-danger" name="' + productId + '"><i class="icon-trash text-danger"></i></button>&nbsp;'+ productName +'</div><input type="hidden" name="product[]" value="' + productId + '">');
      $nameRestrictedProducts.val($nameRestrictedProducts.val() + productName + '¤');
      ($inputRestrictedProducts.val() !== 'undefined')?$inputRestrictedProducts.val($inputRestrictedProducts.val() + productId + '-'):$inputRestrictedProducts.val(productId + '-');
      $('#restricted_product_input').val('');
      $('#restricted_product_input').setOptions({
        extraParams: {
          ajax: true,
          action: 'getProducts',
          excludeIds : getRestrictedProduct()
        }
      });
    }
  }

  function addProduct_1(event, data_1, formatted)
  {
    if (data_1 !== null) {
      var productId_1 = data_1[1];
      var productName_1 = data_1[0];

      var $divRestrictedProducts_1 = $('#divRestrictedProducts_1');
      var $inputRestrictedProducts_1 = $('#inputRestrictedProducts_1');
      var $nameRestrictedProducts_1 = $('#nameRestrictedProducts_1');

      /* delete product from select + add product line to the div, input_name, input_ids elements */
      $divRestrictedProducts_1.html($divRestrictedProducts_1.html() + '<div class="form-control-static panel"><button type="button" class="delRestrictedProducts_1 btn btn-danger" name="' + productId_1 + '"><i class="icon-trash text-danger"></i></button>&nbsp;'+ productName_1 +'</div><input type="hidden" name="select_product[]" value="' + productId_1 + '">');
      $nameRestrictedProducts_1.val($nameRestrictedProducts_1.val() + productName_1 + '¤');
      ($inputRestrictedProducts_1.val() !== 'undefined')?$inputRestrictedProducts_1.val($inputRestrictedProducts_1.val() + productId_1 + '-'):$inputRestrictedProducts_1.val(productId_1 + '-');
      $('#restricted_product_input_1').val('');
      $('#restricted_product_input_1').setOptions({
        extraParams: {
          ajax: true,
          action: 'getProducts',
          excludeIds : getRestrictedProduct_1()
        }
      });
    }
  }

  function getRestrictedProduct() {
    if ($('#inputRestrictedProducts').val() !== undefined) {
      return $('#inputRestrictedProducts').val().replace(/\-/g,',');
    }
  }

  function getRestrictedProduct_1() {
    if ($('#inputRestrictedProducts_1').val() !== undefined) {
      return $('#inputRestrictedProducts_1').val().replace(/\-/g,',');
    }
  }

  function delRestrictedProducts(id)
  {
    var div = getE('divRestrictedProducts');
    var input = getE('inputRestrictedProducts');
    var name = getE('nameRestrictedProducts');

    // Cut hidden fields in array
    var inputCut = input.value.split('-');
    var nameCut = name.value.split('¤');

    if (inputCut.length != nameCut.length) {
      return jAlert('Bad size');
    }

    // Reset all hidden fields
    input.value = '';
    name.value = '';
    div.innerHTML = '';
    for (i in inputCut)
    {
      // If empty, error, next
      if (!inputCut[i] || !nameCut[i]) {
        continue ;
      }

      // Add to hidden fields no selected products OR add to select field selected product
      if (inputCut[i] != id) {
        input.value += inputCut[i] + '-';
        name.value += nameCut[i] + '¤';
        div.innerHTML += '<div class="form-control-static panel"><button type="button" class="delRestrictedProducts btn btn-danger" name="' + inputCut[i] +'"><i class="icon-trash text-danger"></i></button>&nbsp;' + nameCut[i] + '</div><input type="hidden" name="product[]" value="' + inputCut[i] +'">';
      } else {
        $('#selectRestrictedProducts').append('<option selected="selected" value="' + inputCut[i] + '-' + nameCut[i] + '">' + inputCut[i] + ' - ' + nameCut[i] + '</option>');
      }
    }

    $('#restricted_product_input').setOptions({
      extraParams: {
        ajax: true,
        action: 'getProducts',
        excludeIds : getRestrictedProduct()
      }
    });
  };

  function delRestrictedProducts_1(id)
  {
    var div_1 = getE('divRestrictedProducts_1');
    var input_1 = getE('inputRestrictedProducts_1');
    var name_1 = getE('nameRestrictedProducts_1');

    // Cut hidden fields in array
    var inputCut_1 = input_1.value.split('-');
    var nameCut_1 = name_1.value.split('¤');

    if (inputCut_1.length != nameCut_1.length) {
      return jAlert('Bad size');
    }

    // Reset all hidden fields
    input_1.value = '';
    name_1.value = '';
    div_1.innerHTML = '';
    for (i in inputCut_1)
    {
      // If empty, error, next
      if (!inputCut_1[i] || !nameCut_1[i]) {
        continue ;
      }

      // Add to hidden fields no selected products OR add to select field selected product
      if (inputCut_1[i] != id) {
        input_1.value += inputCut_1[i] + '-';
        name_1.value += nameCut_1[i] + '¤';
        div_1.innerHTML += '<div class="form-control-static panel"><button type="button" class="delRestrictedProducts_1 btn btn-danger" name="' + inputCut_1[i] +'"><i class="icon-trash text-danger"></i></button>&nbsp;' + nameCut_1[i] + '</div><input type="hidden" name="select_product[]" value="' + inputCut_1[i] +'">';
      } else {
        $('#selectRestrictedProducts_1').append('<option selected="selected" value="' + inputCut_1[i] + '-' + nameCut_1[i] + '">' + inputCut_1[i] + ' - ' + nameCut_1[i] + '</option>');
      }
    }

    $('#restricted_product_input_1').setOptions({
      extraParams: {
        ajax: true,
        action: 'getProducts',
        excludeIds : getRestrictedProduct_1()
      }
    });
  };


  //for gift product

  $('#divRestrictedProducts_2').delegate('.delRestrictedProducts_2', 'click', function f(){
    self.delRestrictedProducts_2($(this).attr('name'));
  });

  var options_2 = {
    minChars: 1,
    autoFill: true,
    max:20,
    matchContains: true,
    mustMatch:false,
    scroll:false,
    cacheLength:0,
    formatItem: function f(item) {
      var itemStringToReturn_2 = item[item.length - 1];
      for(var istr = 0; istr < item.length - 1;istr++) {
        itemStringToReturn_2 += " " + item[istr];
      }
      return itemStringToReturn_2;
    },
    
  };

   $('#restricted_product_input_2')
  .autocomplete("{$context_link->getAdminLink('Adminaddifyfreegifts') nofilter}&exclude_packs=0&excludeVirtuals=0",options_2)
  .result(addProduct_2);
  $('#restricted_product_input_2').setOptions({
    extraParams: {
      ajax: true,
      action: 'getProducts',
      excludeIds: getRestrictedProduct_2()
    }
  });

  function addProduct_2(event, data_2, formatted)
  {
    if (data_2 !== null) {
      var productId_2 = data_2[1];
      var productName_2 = data_2[0];

      var $divRestrictedProducts_2 = $('#divRestrictedProducts_2');
      var $inputRestrictedProducts_2 = $('#inputRestrictedProducts_2');
      var $nameRestrictedProducts_2 = $('#nameRestrictedProducts_2');

      /* delete product from select + add product line to the div, input_name, input_ids elements */
      $divRestrictedProducts_2.html($divRestrictedProducts_2.html() + '<div class="form-control-static panel"><button type="button" class="delRestrictedProducts_2 btn btn-danger" name="' + productId_2 + '"><i class="icon-trash text-danger"></i></button>&nbsp;'+ productName_2 +'</div><input type="hidden" name="gift_product[]" value="' + productId_2 + '">');
      $nameRestrictedProducts_2.val($nameRestrictedProducts_2.val() + productName_2 + '¤');
      ($inputRestrictedProducts_2.val() !== 'undefined')?$inputRestrictedProducts_2.val($inputRestrictedProducts_2.val() + productId_2 + '-'):$inputRestrictedProducts_2.val(productId_2 + '-');
      $('#restricted_product_input_2').val('');
      $('#restricted_product_input_2').setOptions({
        extraParams: {
          ajax: true,
          action: 'getProducts',
          excludeIds : getRestrictedProduct_2()
        }
      });
    }
  }

  function getRestrictedProduct_2() {
    if ($('#inputRestrictedProducts_2').val() !== undefined) {
      return $('#inputRestrictedProducts_2').val().replace(/\-/g,',');
    }
  }

  function delRestrictedProducts_2(id)
  {
    var div_2 = getE('divRestrictedProducts_2');
    var input_2 = getE('inputRestrictedProducts_2');
    var name_2 = getE('nameRestrictedProducts_2');

    // Cut hidden fields in array
    var inputCut_2 = input_2.value.split('-');
    var nameCut_2 = name_2.value.split('¤');

    if (inputCut_2.length != nameCut_2.length) {
      return jAlert('Bad size');
    }

    // Reset all hidden fields
    input_2.value = '';
    name_2.value = '';
    div_2.innerHTML = '';
    for (i in inputCut_2)
    {
      // If empty, error, next
      if (!inputCut_2[i] || !nameCut_2[i]) {
        continue ;
      }

      // Add to hidden fields no selected products OR add to select field selected product
      if (inputCut_2[i] != id) {
        input_2.value += inputCut_2[i] + '-';
        name_2.value += nameCut_2[i] + '¤';
        div_2.innerHTML += '<div class="form-control-static panel"><button type="button" class="delRestrictedProducts_2 btn btn-danger" name="' + inputCut_2[i] +'"><i class="icon-trash text-danger"></i></button>&nbsp;' + nameCut_2[i] + '</div><input type="hidden" name="gift_product[]" value="' + inputCut_2[i] +'">';
      } else {
        $('#selectRestrictedProducts_2').append('<option selected="selected" value="' + inputCut_2[i] + '-' + nameCut_2[i] + '">' + inputCut_2[i] + ' - ' + nameCut_2[i] + '</option>');
      }
    }

    $('#restricted_product_input_2').setOptions({
      extraParams: {
        ajax: true,
        action: 'getProducts',
        excludeIds : getRestrictedProduct_2()
      }
    });
  };

  // buy product

   $('#divRestrictedProducts_3').delegate('.delRestrictedProducts_3', 'click', function f(){
    self.delRestrictedProducts_3($(this).attr('name'));
  });

  var options_3 = {
    minChars: 1,
    autoFill: true,
    max:20,
    matchContains: true,
    mustMatch:false,
    scroll:false,
    cacheLength:0,
    formatItem: function f(item) {
      var itemStringToReturn_3 = item[item.length - 1];
      for(var istr = 0; istr < item.length - 1;istr++) {
        itemStringToReturn_3 += " " + item[istr];
      }
      return itemStringToReturn_3;
    },
    
  };

   $('#restricted_product_input_3')
  .autocomplete("{$context_link->getAdminLink('Adminaddifyfreegifts') nofilter}&exclude_packs=0&excludeVirtuals=0",options_3)
  .result(addProduct_3);
  $('#restricted_product_input_3').setOptions({
    extraParams: {
      ajax: true,
      action: 'getProducts',
      excludeIds: getRestrictedProduct_3()
    }
  });

  function addProduct_3(event, data_3, formatted)
  {
    if (data_3 !== null) {
      var productId_3 = data_3[1];
      var productName_3 = data_3[0];

      var $divRestrictedProducts_3 = $('#divRestrictedProducts_3');
      var $inputRestrictedProducts_3 = $('#inputRestrictedProducts_3');
      var $nameRestrictedProducts_3 = $('#nameRestrictedProducts_3');

      /* delete product from select + add product line to the div, input_name, input_ids elements */
      $divRestrictedProducts_3.html($divRestrictedProducts_3.html() + '<div class="form-control-static panel"><button type="button" class="delRestrictedProducts_3 btn btn-danger" name="' + productId_3 + '"><i class="icon-trash text-danger"></i></button>&nbsp;'+ productName_3 +'</div><input type="hidden" name="buy_product[]" value="' + productId_3 + '">');
      $nameRestrictedProducts_3.val($nameRestrictedProducts_3.val() + productName_3 + '¤');
      ($inputRestrictedProducts_3.val() !== 'undefined')?$inputRestrictedProducts_3.val($inputRestrictedProducts_3.val() + productId_3 + '-'):$inputRestrictedProducts_3.val(productId_3 + '-');
      $('#restricted_product_input_3').val('');
      $('#restricted_product_input_3').setOptions({
        extraParams: {
          ajax: true,
          action: 'getProducts',
          excludeIds : getRestrictedProduct_3()
        }
      });
    }
  }

  function getRestrictedProduct_3() {
    if ($('#inputRestrictedProducts_3').val() !== undefined) {
      return $('#inputRestrictedProducts_3').val().replace(/\-/g,',');
    }
  }

  function delRestrictedProducts_3(id)
  {
    var div_3 = getE('divRestrictedProducts_3');
    var input_3 = getE('inputRestrictedProducts_3');
    var name_3 = getE('nameRestrictedProducts_3');

    // Cut hidden fields in array
    var inputCut_3 = input_3.value.split('-');
    var nameCut_3 = name_3.value.split('¤');

    if (inputCut_3.length != nameCut_3.length) {
      return jAlert('Bad size');
    }

    // Reset all hidden fields
    input_3.value = '';
    name_3.value = '';
    div_3.innerHTML = '';
    for (i in inputCut_3)
    {
      // If empty, error, next
      if (!inputCut_3[i] || !nameCut_3[i]) {
        continue ;
      }

      // Add to hidden fields no selected products OR add to select field selected product
      if (inputCut_3[i] != id) {
        input_3.value += inputCut_3[i] + '-';
        name_3.value += nameCut_3[i] + '¤';
        div_3.innerHTML += '<div class="form-control-static panel"><button type="button" class="delRestrictedProducts_3 btn btn-danger" name="' + inputCut_3[i] +'"><i class="icon-trash text-danger"></i></button>&nbsp;' + nameCut_3[i] + '</div><input type="hidden" name="buy_product[]" value="' + inputCut_3[i] +'">';
      } else {
        $('#selectRestrictedProducts_3').append('<option selected="selected" value="' + inputCut_3[i] + '-' + nameCut_3[i] + '">' + inputCut_3[i] + ' - ' + nameCut_3[i] + '</option>');
      }
    }

    $('#restricted_product_input_3').setOptions({
      extraParams: {
        ajax: true,
        action: 'getProducts',
        excludeIds : getRestrictedProduct_3()
      }
    });
  };

  // for promotion product

   $('#divRestrictedProducts_4').delegate('.delRestrictedProducts_4', 'click', function f(){
    self.delRestrictedProducts_4($(this).attr('name'));
  });

  var options_4 = {
    minChars: 1,
    autoFill: true,
    max:20,
    matchContains: true,
    mustMatch:false,
    scroll:false,
    cacheLength:0,
    formatItem: function f(item) {
      var itemStringToReturn_4 = item[item.length - 1];
      for(var istr = 0; istr < item.length - 1;istr++) {
        itemStringToReturn_4 += " " + item[istr];
      }
      return itemStringToReturn_4;
    },
    
  };

   $('#restricted_product_input_4')
  .autocomplete("{$context_link->getAdminLink('Adminaddifyfreegifts') nofilter}&exclude_packs=0&excludeVirtuals=0",options_4)
  .result(addProduct_4);
  $('#restricted_product_input_4').setOptions({
    extraParams: {
      ajax: true,
      action: 'getProducts',
      excludeIds: getRestrictedProduct_4()
    }
  });

  function addProduct_4(event, data_4, formatted)
  {
    if (data_4 !== null) {
      var productId_4 = data_4[1];
      var productName_4 = data_4[0];

      var $divRestrictedProducts_4 = $('#divRestrictedProducts_4');
      var $inputRestrictedProducts_4 = $('#inputRestrictedProducts_4');
      var $nameRestrictedProducts_4 = $('#nameRestrictedProducts_4');

      /* delete product from select + add product line to the div, input_name, input_ids elements */
      $divRestrictedProducts_4.html($divRestrictedProducts_4.html() + '<div class="form-control-static panel"><button type="button" class="delRestrictedProducts_4 btn btn-danger" name="' + productId_4 + '"><i class="icon-trash text-danger"></i></button>&nbsp;'+ productName_4 +'</div><input type="hidden" name="promotion_product[]" value="' + productId_4 + '">');
      $nameRestrictedProducts_4.val($nameRestrictedProducts_4.val() + productName_4 + '¤');
      ($inputRestrictedProducts_4.val() !== 'undefined')?$inputRestrictedProducts_4.val($inputRestrictedProducts_4.val() + productId_4 + '-'):$inputRestrictedProducts_4.val(productId_4 + '-');
      $('#restricted_product_input_4').val('');
      $('#restricted_product_input_4').setOptions({
        extraParams: {
          ajax: true,
          action: 'getProducts',
          excludeIds : getRestrictedProduct_4()
        }
      });
    }
  }

  function getRestrictedProduct_4() {
    if ($('#inputRestrictedProducts_4').val() !== undefined) {
      return $('#inputRestrictedProducts_4').val().replace(/\-/g,',');
    }
  }

  function delRestrictedProducts_4(id)
  {
    var div_4 = getE('divRestrictedProducts_4');
    var input_4 = getE('inputRestrictedProducts_4');
    var name_4 = getE('nameRestrictedProducts_4');

    // Cut hidden fields in array
    var inputCut_4 = input_4.value.split('-');
    var nameCut_4 = name_4.value.split('¤');

    if (inputCut_4.length != nameCut_4.length) {
      return jAlert('Bad size');
    }

    // Reset all hidden fields
    input_4.value = '';
    name_4.value = '';
    div_4.innerHTML = '';
    for (i in inputCut_4)
    {
      // If empty, error, next
      if (!inputCut_4[i] || !nameCut_4[i]) {
        continue ;
      }

      // Add to hidden fields no selected products OR add to select field selected product
      if (inputCut_4[i] != id) {
        input_4.value += inputCut_4[i] + '-';
        name_4.value += nameCut_4[i] + '¤';
        div_4.innerHTML += '<div class="form-control-static panel"><button type="button" class="delRestrictedProducts_4 btn btn-danger" name="' + inputCut_4[i] +'"><i class="icon-trash text-danger"></i></button>&nbsp;' + nameCut_4[i] + '</div><input type="hidden" name="promotion_product[]" value="' + inputCut_4[i] +'">';
      } else {
        $('#selectRestrictedProducts_4').append('<option selected="selected" value="' + inputCut_4[i] + '-' + nameCut_4[i] + '">' + inputCut_4[i] + ' - ' + nameCut_4[i] + '</option>');
      }
    }

    $('#restricted_product_input_4').setOptions({
      extraParams: {
        ajax: true,
        action: 'getProducts',
        excludeIds : getRestrictedProduct_4()
      }
    });
  };

  $( document ).ready(function() {

    // var x = document.getElementsByName("gift_type");
    // for (var i = 0; i < x.length; i++) {
    //   if(x[i].checked){
    //     if (x[i].value == 0) {
    //       $("#buy_quantity").parent().parent().hide();
    //       $("#get_quantity").parent().parent().show();
    //       $("#type_product_1").parent().parent().show();
    //       $("#cart_amount").parent().parent().show();
    //       $("#Buy_products").parent().parent().parent().parent().show();

    //       var y = document.getElementsByName("condition_option");
    //       for (var j = 0; j < y.length; j++) {
            
    //         if(y[j].checked){
    //           if (y[j].value == 0) {
    //             $("#buy_all_products").parent().parent().parent().parent().show();
    //             $("#type_product").parent().parent().show();
    //             $("#cart_amount").parent().parent().hide();
    //           }

    //           if (y[j].value == 1) {
    //             $("#buy_all_products").parent().parent().parent().parent().hide();
    //             $("#type_product").parent().parent().hide();
    //             $("#cart_amount").parent().parent().show();
    //           }
    //         }
    //       }
    //     }

    //     if (x[i].value == 1) {
    //       $("#buy_quantity").parent().parent().hide();
    //       $("#get_quantity").parent().parent().show();
    //       $("#type_product_1").parent().parent().show();
    //       $("#cart_amount").parent().parent().show();
    //       $("#Buy_products").parent().parent().parent().parent().show();

    //       var y = document.getElementsByName("condition_option");
    //       for (var j = 0; j < y.length; j++) {
            
    //         if(y[j].checked){
    //           if (y[j].value == 0) {
    //             $("#buy_all_products").parent().parent().parent().parent().show();
    //             $("#type_product").parent().parent().show();
    //             $("#cart_amount").parent().parent().hide();
    //           }

    //           if (y[j].value == 1) {
    //             $("#buy_all_products").parent().parent().parent().parent().hide();
    //             $("#type_product").parent().parent().hide();
    //             $("#cart_amount").parent().parent().show();
    //           }
    //         }
    //       }
    //     }

    //     if (x[i].value == 2) {
    //       $("#get_quantity").parent().parent().show();
    //       $("#buy_quantity").parent().parent().show();
    //       $("#type_product_1").parent().parent().show();
    //       $("#cart_amount").parent().parent().hide();
    //       $("#Buy_products").parent().parent().parent().parent().hide();
    //       $("#type_product").parent().parent().show();
    //       $("#buy_all_products").parent().parent().parent().parent().show();
    //     }
    //   }
    // }

    // var y = document.getElementsByName("condition_option");
    // for (var j = 0; j < y.length; j++) {
      
    //   if(y[j].checked){
    //     if (y[j].value == 0) {
    //       $("#buy_all_products").parent().parent().parent().parent().show();
    //       $("#type_product").parent().parent().show();
    //       $("#cart_amount").parent().parent().hide();
    //     }

    //     if (y[j].value == 1) {
    //       $("#buy_all_products").parent().parent().parent().parent().hide();
    //       $("#type_product").parent().parent().hide();
    //       $("#cart_amount").parent().parent().show();
    //     }
    //   }
    // }

    // $("#Automatic").click(function(){
    //   $("#buy_quantity").parent().parent().hide();
    //   $("#get_quantity").parent().parent().show();
    //   $("#type_product_1").parent().parent().show();
    //   $("#cart_amount").parent().parent().show();
    //   $("#Buy_products").parent().parent().parent().parent().show();

    //   var y = document.getElementsByName("condition_option");
    //   for (var j = 0; j < y.length; j++) {
        
    //     if(y[j].checked){
    //       if (y[j].value == 0) {
    //         $("#buy_all_products").parent().parent().parent().parent().show();
    //         $("#type_product").parent().parent().show();
    //         $("#cart_amount").parent().parent().hide();
    //       }

    //       if (y[j].value == 1) {
    //         $("#buy_all_products").parent().parent().parent().parent().hide();
    //         $("#type_product").parent().parent().hide();
    //         $("#cart_amount").parent().parent().show();
    //       }
    //     }
    //   }
    // });

    // $("#Manual").click(function(){
    //   $("#buy_quantity").parent().parent().hide();
    //   $("#get_quantity").parent().parent().show();
    //   $("#type_product_1").parent().parent().show();
    //   $("#cart_amount").parent().parent().show();
    //   $("#Buy_products").parent().parent().parent().parent().show();

    //   var y = document.getElementsByName("condition_option");
    //   for (var j = 0; j < y.length; j++) {
        
    //     if(y[j].checked){
    //       if (y[j].value == 0) {
    //         $("#buy_all_products").parent().parent().parent().parent().show();
    //         $("#type_product").parent().parent().show();
    //         $("#cart_amount").parent().parent().hide();
    //       }

    //       if (y[j].value == 1) {
    //         $("#buy_all_products").parent().parent().parent().parent().hide();
    //         $("#type_product").parent().parent().hide();
    //         $("#cart_amount").parent().parent().show();
    //       }
    //     }
    //   }
    // });

    // $("#Buy_one").click(function(){
    //   $("#get_quantity").parent().parent().show();
    //   $("#buy_quantity").parent().parent().show();
    //   $("#type_product_1").parent().parent().show();
    //   $("#cart_amount").parent().parent().hide();
    //   $("#Buy_products").parent().parent().parent().parent().hide();
    //   $("#type_product").parent().parent().show();
    //   $("#buy_all_products").parent().parent().parent().parent().show();
    // });

    // $("#Buy_products").click(function(){
    //   $("#type_product").parent().parent().show();
    //   $("#cart_amount").parent().parent().hide();
    //   $("#buy_all_products").parent().parent().parent().parent().show();
    // });

    // $("#Total_Cart_bill").click(function(){
    //   $("#type_product").parent().parent().hide();
    //   $("#cart_amount").parent().parent().show();
    //   $("#buy_all_products").parent().parent().parent().parent().hide();
    // });



if (document.getElementById('addifyfreegiftspredefined_form')) {

    var x = document.getElementsByName("userbuy_type");
    for (var i = 0; i < x.length; i++) {
      if(x[i].checked){
        if (x[i].value == 0) {
          $("#buy_category").parent().parent().hide();
          $("#buy_supplier").parent().parent().hide();
          $("#type_product_3").parent().parent().hide();
        }

        if (x[i].value == 1) {
          $("#buy_category").parent().parent().hide();
          $("#buy_supplier").parent().parent().hide();
          $("#type_product_3").parent().parent().show();
        }

        if (x[i].value == 2) {
          $("#buy_category").parent().parent().show();
          $("#buy_supplier").parent().parent().hide();
          $("#type_product_3").parent().parent().hide();
        }

        if (x[i].value == 3) {
          $("#buy_category").parent().parent().hide();
          $("#buy_supplier").parent().parent().show();
          $("#type_product_3").parent().parent().hide();
        }
      }
    }
}

    var x = document.getElementsByName("giftbuy_type");
    for (var i = 0; i < x.length; i++) {
      if(x[i].checked){
        if (x[i].value == 0) {
          $("#gift_category").parent().parent().hide();
          $("#gift_supplier").parent().parent().hide();
          $("#type_product_2").parent().parent().hide();
        }

        if (x[i].value == 1) {
          $("#gift_category").parent().parent().hide();
          $("#gift_supplier").parent().parent().hide();
          $("#type_product_2").parent().parent().show();
        }

        if (x[i].value == 2) {
          $("#gift_category").parent().parent().show();
          $("#gift_supplier").parent().parent().hide();
          $("#type_product_2").parent().parent().hide();
        }

        if (x[i].value == 3) {
          $("#gift_category").parent().parent().hide();
          $("#gift_supplier").parent().parent().show();
          $("#type_product_2").parent().parent().hide();
        }
      }
    }

    var x = document.getElementsByName("condition_type");
    for (var i = 0; i < x.length; i++) {
      if(x[i].checked){
        if (x[i].value == 0) {
          $("#category").parent().parent().hide();
          $("#supplier").parent().parent().hide();
          $("#type_product_4").parent().parent().hide();
        }

        if (x[i].value == 1) {
          $("#category").parent().parent().hide();
          $("#supplier").parent().parent().hide();
          $("#type_product_4").parent().parent().show();
        }

        if (x[i].value == 2) {
          $("#category").parent().parent().show();
          $("#supplier").parent().parent().hide();
          $("#type_product_4").parent().parent().hide();
        }

        if (x[i].value == 3) {
          $("#category").parent().parent().hide();
          $("#supplier").parent().parent().show();
          $("#type_product_4").parent().parent().hide();
        }
      }
    }

    $("#buyanyproduct").click(function(){
      $("#buy_category").parent().parent().hide();
      $("#buy_supplier").parent().parent().hide();
      $("#type_product_3").parent().parent().hide();
    });

    $("#buyselectedproduct").click(function(){
      $("#buy_category").parent().parent().hide();
      $("#buy_supplier").parent().parent().hide();
      $("#type_product_3").parent().parent().show();
    });

    $("#buyselectedcategory").click(function(){
      $("#buy_category").parent().parent().show();
      $("#buy_supplier").parent().parent().hide();
      $("#type_product_3").parent().parent().hide();
    });

    $("#buyselectedcsupplier").click(function(){
      $("#buy_category").parent().parent().hide();
      $("#buy_supplier").parent().parent().show();
      $("#type_product_3").parent().parent().hide();
    });

    $("#giftanyproduct").click(function(){
      $("#gift_category").parent().parent().hide();
      $("#gift_supplier").parent().parent().hide();
      $("#type_product_2").parent().parent().hide();
    });

    $("#giftselectedproduct").click(function(){
      $("#gift_category").parent().parent().hide();
      $("#gift_supplier").parent().parent().hide();
      $("#type_product_2").parent().parent().show();
    });

    $("#giftselectedcategory").click(function(){
      $("#gift_category").parent().parent().show();
      $("#gift_supplier").parent().parent().hide();
      $("#type_product_2").parent().parent().hide();
    });

    $("#giftselectedcsupplier").click(function(){
      $("#gift_category").parent().parent().hide();
      $("#gift_supplier").parent().parent().show();
      $("#type_product_2").parent().parent().hide();
    });







     $("#whole").click(function(){
      $("#category").parent().parent().hide();
      $("#supplier").parent().parent().hide();
      $("#type_product_4").parent().parent().hide();
    });

    $("#Products").click(function(){
      $("#category").parent().parent().hide();
      $("#supplier").parent().parent().hide();
      $("#type_product_4").parent().parent().show();
    });

    $("#Categories").click(function(){
      $("#category").parent().parent().show();
      $("#supplier").parent().parent().hide();
      $("#type_product_4").parent().parent().hide();
    });

    $("#Suppliers").click(function(){
      $("#category").parent().parent().hide();
      $("#supplier").parent().parent().show();
      $("#type_product_4").parent().parent().hide();
    });





  // for custom rules


if (document.getElementById('addifyfreegifts_form')) {

  var x = document.getElementsByName("condition_option");
    for (var i = 0; i < x.length; i++) {
      if(x[i].checked){
        if (x[i].value == 0) {
          $("#buy_quantity").parent().parent().show();
          $("#custombuyselectedproduct").parent().parent().parent().parent().show();
          $("#cart_amount").parent().parent().hide();
          $("#custom_buy_supplier").parent().parent().hide();
          $("#type_product").parent().parent().hide();

          var y = document.getElementsByName("userbuy_type");
          for (var k = 0; k < x.length; k++) {
            if(y[k].checked){
              if (y[k].value == 1) {
                $("#custom_buy_category").parent().parent().hide();
                $("#custom_buy_supplier").parent().parent().hide();
                $("#type_product").parent().parent().hide();
              }

              if (y[k].value == 0) {
                $("#custom_buy_category").parent().parent().hide();
                $("#custom_buy_supplier").parent().parent().hide();
                $("#type_product").parent().parent().show();
              }

              if (y[k].value == 2) {
                $("#custom_buy_category").parent().parent().show();
                $("#custom_buy_supplier").parent().parent().hide();
                $("#type_product").parent().parent().hide();
              }

              if (y[k].value == 3) {
                $("#custom_buy_category").parent().parent().hide();
                $("#custom_buy_supplier").parent().parent().show();
                $("#type_product").parent().parent().hide();
              }
            }
          }
        }
        if (x[i].value == 1) {
          $("#buy_quantity").parent().parent().hide();
          $("#custom_buy_supplier").parent().parent().hide();
          $("#custom_buy_category").parent().parent().hide();
          $("#type_product").parent().parent().hide();
          $("#custombuyselectedproduct").parent().parent().parent().parent().hide();
          $("#cart_amount").parent().parent().show();
          $("#custom_buy_x").parent().parent().hide();
        }
      }
    }
}

    $("#buyXgetY").click(function(){
      $("#buy_quantity").parent().parent().show();
      $("#custombuyselectedproduct").parent().parent().parent().parent().show();
      $("#cart_amount").parent().parent().hide();
      $("#custom_buy_x").parent().parent().show();

      var x = document.getElementsByName("userbuy_type");
      for (var i = 0; i < x.length; i++) {
        if(x[i].checked){
          if (x[i].value == 1) {
            $("#custom_buy_category").parent().parent().hide();
            $("#custom_buy_supplier").parent().parent().hide();
            $("#type_product").parent().parent().hide();
          }

          if (x[i].value == 0) {
            $("#custom_buy_category").parent().parent().hide();
            $("#custom_buy_supplier").parent().parent().hide();
            $("#type_product").parent().parent().show();
          }

          if (x[i].value == 2) {
            $("#custom_buy_category").parent().parent().show();
            $("#custom_buy_supplier").parent().parent().hide();
            $("#type_product").parent().parent().hide();
          }

          if (x[i].value == 3) {
            $("#custom_buy_category").parent().parent().hide();
            $("#custom_buy_supplier").parent().parent().show();
            $("#type_product").parent().parent().hide();
          }
        }
      }
    });

    $("#basedcartvalue").click(function(){
      $("#buy_quantity").parent().parent().hide();
      $("#custom_buy_supplier").parent().parent().hide();
      $("#custom_buy_category").parent().parent().hide();
      $("#type_product").parent().parent().hide();
      $("#custombuyselectedproduct").parent().parent().parent().parent().hide();
      $("#cart_amount").parent().parent().show();
      $("#custom_buy_x").parent().parent().hide();
      
    });

    $("#custombuyanyproduct").click(function(){
      $("#buy_quantity").parent().parent().show();
      $("#custom_buy_supplier").parent().parent().hide();
      $("#custom_buy_category").parent().parent().hide();
      $("#type_product").parent().parent().hide();
      $("#cart_amount").parent().parent().hide();
      
    });

    $("#custombuyselectedproduct").click(function(){
      $("#buy_quantity").parent().parent().show();
      $("#custom_buy_supplier").parent().parent().hide();
      $("#custom_buy_category").parent().parent().hide();
      $("#type_product").parent().parent().show();
      $("#cart_amount").parent().parent().hide();
      
    });

    $("#custombuyselectedcategory").click(function(){
      $("#buy_quantity").parent().parent().show();
      $("#custom_buy_supplier").parent().parent().hide();
      $("#custom_buy_category").parent().parent().show();
      $("#type_product").parent().parent().hide();
      $("#cart_amount").parent().parent().hide();
      
    });

    $("#custombuyselectedcsupplier").click(function(){
      $("#buy_quantity").parent().parent().show();
      $("#custom_buy_supplier").parent().parent().show();
      $("#custom_buy_category").parent().parent().hide();
      $("#type_product").parent().parent().hide();
      $("#cart_amount").parent().parent().hide();
      
    });

    $("#customgiftanyproduct").click(function(){
      $("#custom_gift_category").parent().parent().hide();
      $("#custom_gift_supplier").parent().parent().hide();
      $("#type_product_1").parent().parent().hide();
    });

    $("#customgiftselectedproduct").click(function(){
      $("#custom_gift_category").parent().parent().hide();
      $("#custom_gift_supplier").parent().parent().hide();
      $("#type_product_1").parent().parent().show();
    });

    $("#customgiftselectedcategory").click(function(){
      $("#custom_gift_category").parent().parent().show();
      $("#custom_gift_supplier").parent().parent().hide();
      $("#type_product_1").parent().parent().hide();
    });

    $("#customgiftselectedcsupplier").click(function(){
      $("#custom_gift_category").parent().parent().hide();
      $("#custom_gift_supplier").parent().parent().show();
      $("#type_product_1").parent().parent().hide();
    });

    

    var x = document.getElementsByName("giftbuy_type");
    for (var i = 0; i < x.length; i++) {
      if(x[i].checked){
        if (x[i].value == 1) {
          $("#custom_gift_category").parent().parent().hide();
          $("#custom_gift_supplier").parent().parent().hide();
          $("#type_product_1").parent().parent().hide();
        }

        if (x[i].value == 0) {
          $("#custom_gift_category").parent().parent().hide();
          $("#custom_gift_supplier").parent().parent().hide();
          $("#type_product_1").parent().parent().show();
        }

        if (x[i].value == 2) {
          $("#custom_gift_category").parent().parent().show();
          $("#custom_gift_supplier").parent().parent().hide();
          $("#type_product_1").parent().parent().hide();
        }

        if (x[i].value == 3) {
          $("#custom_gift_category").parent().parent().hide();
          $("#custom_gift_supplier").parent().parent().show();
          $("#type_product_1").parent().parent().hide();
        }
      }
    }

  });
  
{/block}
