{**
 * 2007-2024 PrestaShop and Contributors
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Academic Free License 3.0 (AFL-3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * https://opensource.org/licenses/AFL-3.0
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please refer to https://www.prestashop.com for more information.
 *
 * @author    PrestaShop SA <contact@prestashop.com>
 * @copyright 2007-2024 PrestaShop SA and Contributors
 * @license   https://opensource.org/licenses/AFL-3.0 Academic Free License 3.0 (AFL-3.0)
 * International Registered Trademark & Property of PrestaShop SA
 *}

 <style type="text/css">
 	.m_card{
 		box-shadow: 2px 2px 8px 0 rgb(0 0 0 / 20%);
 		position: relative;
    display: block;
    margin-bottom: .75rem;
    background-color: #fff;
    border-radius: 0;
    border: 1px solid rgba(0,0,0,.125);
 	}

 	.m_card_block {
	    padding: 1rem;
	}

	.m_cart_overview {
	    padding: 1rem;
	}

	.m_cart_tems {
	    margin-bottom: 0;
	}

	.m_cart_item {
	    padding: 1rem 0;
	}
 </style>

<div id="manualgift" class="m_card" style="display: none;">
    <div class="m_card_block">
    	<h1 class="h1">{l s='Choose your Gifts' mod='addifyfreegifts'}</h1>
    </div>
    <hr class="separator">
		<!-- begin checkout/_partials/cart-detailed.tpl -->
	{foreach from=$product_details item=product_detail}
	<div class="m_cart_overview">
	    <ul class="m_cart_tems">
	        <li class="m_cart_item">
	            <div>
					<!--  product left content: image-->
					<div class="col-md-3">
					    <span>
					      	<img  style="max-width: 80px;" src="http://{$product_detail['img_url']|escape:'htmlall':'UTF-8'}" alt="{$product_detail['product_name']|escape:'htmlall':'UTF-8'}">
					    </span>
					</div>
				 	<!--  product left body: description -->
					<div class="col-md-4" style="padding-top: 28px; padding-left: 0px;">
					    <div>
					      	<a class="label" href="http://{$product_detail['img_url']|escape:'htmlall':'UTF-8'}">{$product_detail['product_name']|escape:'htmlall':'UTF-8'}</a>
					    </div>
					</div>
					<!--  product left body: description -->
					<div class="col-md-5">
					    <div class="row">
	                        <div class="bootstrap-touchspin" style="margin-top: 20px; ">
	                        	<input class="form-control" data-product-id="3" type="number" 
	                        	value="{$product_detail['product_quan']|escape:'htmlall':'UTF-8'}" name="product-quantity"  readonly
	                        	 style="display: block; text-align: center;">
	                        </div>
				          	<div style="padding-left: 135px; padding-top: 20px;">
				          		<button class="btn btn-primary" type="submit" onclick="afg_addtocart(
				          		{$product_detail['product_id']|escape:'htmlall':'UTF-8'},
				          		{$product_detail['default_attribute']|escape:'htmlall':'UTF-8'}, 
				          		{$product_detail['id_shop']|escape:'htmlall':'UTF-8'}, 
				          		{$product_detail['id_country']|escape:'htmlall':'UTF-8'}, 
				          		{$product_detail['id_currency']|escape:'htmlall':'UTF-8'}, 
				          		{$product_detail['id_customer']|escape:'htmlall':'UTF-8'}, 
				          		{$product_detail['id_cart']|escape:'htmlall':'UTF-8'},
				          		{$product_detail['product_quan']|escape:'htmlall':'UTF-8'}, 
				          		{$product_detail['group_id']|escape:'htmlall':'UTF-8'}, 
				          		{$product_detail['id_rule']|escape:'htmlall':'UTF-8'},
				          		'{$product_detail['Validity_from']|escape:'htmlall':'UTF-8'}',
				          		'{$product_detail['Validity_to']|escape:'htmlall':'UTF-8'}')">
				          		{l s='Add to cart' mod='addifyfreegifts'}
				          		</button>
					        </div>
					    </div>
					</div>
					<div class="clearfix"></div>
			    </div>     
	        </li>
      	</ul>
	</div>
	{/foreach}
	<!-- end checkout/_partials/cart-detailed.tpl -->
	<input type="hidden" name="Y_quantity" id="Y_quantity" value="{$get_Y|escape:'htmlall':'UTF-8'}">
	<input type="hidden" name="giftpro_quan" id="giftpro_quan" value="{$giftpro_quan|escape:'htmlall':'UTF-8'}">
	<input type="hidden" name="afg_gift_rule" id="afg_gift_rule" value="{$gift_rule|escape:'htmlall':'UTF-8'}">
</div>
